From: Paul Tan <pyokagan@gmail.com>
To: git@vger.kernel.org
Cc: Johannes Schindelin <johannes.schindelin@gmx.de>,
Stefan Beller <sbeller@google.com>, Paul Tan <pyokagan@gmail.com>,
Junio C Hamano <gitster@pobox.com>
Subject: [PATCH 08/12] t4150: am with pre-applypatch hook
Date: Fri, 3 Jul 2015 02:16:36 +0800 [thread overview]
Message-ID: <1435861000-25278-9-git-send-email-pyokagan@gmail.com> (raw)
In-Reply-To: <1435861000-25278-1-git-send-email-pyokagan@gmail.com>
Since d1c5f2a (Add git-am, applymbox replacement., 2005-10-07),
git-am.sg will invoke the pre-applypatch hook after applying the patch
to the index, but before a commit is made. Should the hook exit with a
non-zero status, git am will exit.
Add tests for this hook.
Cc: Junio C Hamano <gitster@pobox.com>
Signed-off-by: Paul Tan <pyokagan@gmail.com>
---
t/t4150-am.sh | 38 ++++++++++++++++++++++++++++++++++++++
1 file changed, 38 insertions(+)
diff --git a/t/t4150-am.sh b/t/t4150-am.sh
index 24c1b42..dd6fe81 100755
--- a/t/t4150-am.sh
+++ b/t/t4150-am.sh
@@ -237,6 +237,44 @@ test_expect_success 'am with failing applypatch-msg hook' '
test_cmp_rev first HEAD
'
+test_expect_success 'am with pre-applypatch hook' '
+ test_when_finished "rm -f .git/hooks/pre-applypatch" &&
+ rm -fr .git/rebase-apply &&
+ git reset --hard &&
+ git checkout first &&
+ mkdir -p .git/hooks &&
+ cat >.git/hooks/pre-applypatch <<-\EOF &&
+ #!/bin/sh
+ git diff first >diff.actual
+ exit 0
+ EOF
+ chmod +x .git/hooks/pre-applypatch &&
+ git am patch1 &&
+ test_path_is_missing .git/rebase-apply &&
+ git diff --exit-code second &&
+ test_cmp_rev second HEAD &&
+ test_cmp_rev second^ HEAD^ &&
+ git diff first..second >diff.expected &&
+ test_cmp diff.expected diff.actual
+'
+
+test_expect_success 'am with failing pre-applypatch hook' '
+ test_when_finished "rm -f .git/hooks/pre-applypatch" &&
+ rm -fr .git/rebase-apply &&
+ git reset --hard &&
+ git checkout first &&
+ mkdir -p .git/hooks &&
+ cat >.git/hooks/pre-applypatch <<-\EOF &&
+ #!/bin/sh
+ exit 1
+ EOF
+ chmod +x .git/hooks/pre-applypatch &&
+ test_must_fail git am patch1 &&
+ test_path_is_dir .git/rebase-apply &&
+ git diff --exit-code second &&
+ test_cmp_rev first HEAD
+'
+
test_expect_success 'setup: new author and committer' '
GIT_AUTHOR_NAME="Another Thor" &&
GIT_AUTHOR_EMAIL="a.thor@example.com" &&
--
2.5.0.rc1.81.gfe77482
next prev parent reply other threads:[~2015-07-02 18:17 UTC|newest]
Thread overview: 26+ messages / expand[flat|nested] mbox.gz Atom feed top
2015-07-02 18:16 [PATCH 00/12] Improve git-am test coverage Paul Tan
2015-07-02 18:16 ` [PATCH 01/12] t4150: am.messageid really adds the message id Paul Tan
2015-07-02 18:41 ` Paolo Bonzini
2015-07-06 17:38 ` Junio C Hamano
2015-07-02 18:16 ` [PATCH 02/12] t4150: am fails if index is dirty Paul Tan
2015-07-05 15:38 ` Johannes Schindelin
2015-07-07 6:35 ` Paul Tan
2015-07-02 18:16 ` [PATCH 03/12] t4151: am --abort will keep dirty index intact Paul Tan
2015-07-02 18:16 ` [PATCH 04/12] t4150: am refuses patches when paused Paul Tan
2015-07-02 18:16 ` [PATCH 05/12] t4150: am --resolved fails if index has no changes Paul Tan
2015-07-02 18:16 ` [PATCH 06/12] t4150: am --resolved fails if index has unmerged entries Paul Tan
2015-07-02 18:16 ` [PATCH 07/12] t4150: am with applypatch-msg hook Paul Tan
2015-07-06 17:46 ` Junio C Hamano
2015-07-02 18:16 ` Paul Tan [this message]
2015-07-02 18:16 ` [PATCH 09/12] t4150: am with post-applypatch hook Paul Tan
2015-07-05 15:58 ` Johannes Schindelin
2015-07-07 6:47 ` Paul Tan
2015-07-07 8:07 ` Johannes Schindelin
2015-07-02 18:16 ` [PATCH 10/12] t4150: tests for am --[no-]scissors Paul Tan
2015-07-02 18:16 ` [PATCH 11/12] t3418: non-interactive rebase --continue with rerere enabled Paul Tan
2015-07-02 18:16 ` [PATCH 12/12] t3901: test git-am encoding conversion Paul Tan
2015-07-08 20:44 ` Johannes Sixt
2015-07-14 9:43 ` Paul Tan
2015-07-03 16:24 ` [PATCH 00/12] Improve git-am test coverage Stefan Beller
2015-07-05 16:02 ` Johannes Schindelin
2015-07-06 20:42 ` Junio C Hamano
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
List information: http://vger.kernel.org/majordomo-info.html
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1435861000-25278-9-git-send-email-pyokagan@gmail.com \
--to=pyokagan@gmail.com \
--cc=git@vger.kernel.org \
--cc=gitster@pobox.com \
--cc=johannes.schindelin@gmx.de \
--cc=sbeller@google.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
Code repositories for project(s) associated with this public inbox
https://80x24.org/mirrors/git.git
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).